# std::unexpected

From cppreference.com
< cpp‎ | error

Defined in header `<exception>` |  |
void unexpected(); |  | (until C++11)
[[noreturn]] void unexpected(); |  | (until C++17) (since c++11, deprecated in C++11)

`std::unexpected()` is called by the C++ runtime when a dynamic exception specification is violated: an exception is thrown from a function whose exception specification forbids exceptions of this type.

`std::unexpected()` may also be called directly from the program.

In either case, `std::unexpected` calls the currently installed std::unexpected_handler. The default std::unexpected_handler calls std::terminate.

If a destructor reset the unexpected handler during stack unwinding and the unwinding later led to `unexpected` being called, the handler that was installed at the end of the throw expression is the one that will be called. (note: it was ambiguous whether re-throwing applied the new handlers) | (until C++11)
If a destructor reset the unexpected handler during stack unwinding, it is unspecified which handler is called if the unwinding later led to `unexpected` being called. | (since C++17)

### Parameters

(none)

### Return value

(none)

### Exceptions

Throw any exception thrown by the currently installed std::unexpected_handler

### See also

unexpected_handler (until C++17) | the type of the function called by std::unexpected (typedef)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/unexpected&oldid=88686"